unit ConnProp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Ras;

type
  TfrmConnProp = class(TForm)
    lblName: TLabel;
    txtName: TEdit;
    grpOptions: TGroupBox;
    chkUseCountryAndAreaCodes: TCheckBox;
    chkSpecificIpAddr: TCheckBox;
    chkSpecificNameServers: TCheckBox;
    chkIpHeaderCompression: TCheckBox;
    chkRemoteDefaultGateway: TCheckBox;
    chkDisableLcpExtensions: TCheckBox;
    chkTerminalBeforeDial: TCheckBox;
    chkTerminalAfterDial: TCheckBox;
    chkModemLights: TCheckBox;
    chkSwCompression: TCheckBox;
    chkRequireEncryptedPw: TCheckBox;
    chkRequireMsEncryptedPw: TCheckBox;
    chkRequireDataEncryption: TCheckBox;
    chkNetworkLogon: TCheckBox;
    chkUseLogonCredentials: TCheckBox;
    chkPromoteAlternates: TCheckBox;
    chkSecureLocalFiles: TCheckBox;
    lblCountryID: TLabel;
    txtCountryID: TEdit;
    lblCountryCode: TLabel;
    lblAreaCode: TLabel;
    txtAreaCode: TEdit;
    lblPhoneNumber: TLabel;
    txtPhoneNumber: TEdit;
    grpProtocols: TGroupBox;
    chkNetBEUI: TCheckBox;
    chkIPX: TCheckBox;
    chkIP: TCheckBox;
    optFraming: TRadioGroup;
    lblFrameSize: TLabel;
    txtFrameSize: TEdit;
    lblScript: TLabel;
    txtScript: TEdit;
    lblIPAddr: TLabel;
    txtIpAddr: TEdit;
    lblPrimaryDNS: TLabel;
    txtPrimaryDNS: TEdit;
    lblSecondaryDNS: TLabel;
    txtSecondaryDNS: TEdit;
    lblPrimaryWINS: TLabel;
    txtPrimaryWINS: TEdit;
    lblSecondaryWINS: TLabel;
    txtSecondaryWINS: TEdit;
    txtCountryCode: TEdit;
    btnOk: TButton;
    btnCancel: TButton;
    lblDevice: TLabel;
    cboDevice: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure chkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure check_controls;
  public
    { Public declarations }
  end;

var
  frmConnProp: TfrmConnProp;

implementation

{$R *.DFM}
procedure TfrmConnProp.check_controls;
  var
    b: Boolean;
  begin
  b := chkUseCountryAndAreaCodes.Checked;
  txtCountryID.Enabled := b;
  txtCountryCode.Enabled := b;
  txtAreaCode.Enabled := b;
  txtIpAddr.Enabled := chkSpecificIpAddr.Checked;
  b := chkSpecificNameServers.Checked;
  txtPrimaryDNS.Enabled := b;
  txtSecondaryDNS.Enabled := b;
  txtPrimaryWINS.Enabled := b;
  txtSecondaryWINS.Enabled := b;
  b := chkRequireMsEncryptedPw.Checked;
  chkRequireDataEncryption.Enabled := b;
  chkUseLogonCredentials.Enabled := b;
  txtFrameSize.Enabled := optFraming.ItemIndex = 1;
  end;

procedure TfrmConnProp.FormShow(Sender: TObject);
  begin
  check_controls;
  end;

procedure TfrmConnProp.chkClick(Sender: TObject);
  begin
  check_controls;
  end;

procedure TfrmConnProp.FormCreate(Sender: TObject);
  var
    buffer: Pointer;
    devices: LPRasDevInfo;
    devSize, ndevs: Integer;
  begin
  devSize := 0;
  ndevs := 0;
  if RasEnumDevices(nil, devSize, ndevs) <> ERROR_BUFFER_TOO_SMALL then
    ShowMessage('RasEnumDevices failed.');
  buffer := AllocMem(devSize);
  try
    devices := buffer;
    devices^.dwSize := SizeOf(TRasDevInfo);
    if RasEnumDevices(buffer, devSize, ndevs) = 0 then
      begin
      while ndevs > 0 do
        begin
        cboDevice.Items.Add(Format('%s=%s', [devices^.szDeviceName, devices^.szDeviceType]));
        Inc(devices);
        Dec(ndevs);
        end;
      end
    else
      ShowMessage('RasEnumDevices failed.');
  finally
    FreeMem(buffer);
    end;
  end;

end.
